#include <textmenu.h>
#include <function.h>

#include <string.h>
#include <stdlib.h> /*malloc*/
#include <dir.h>
#include <bios.h> /*biosdisk*/

#define MEM_FILES 100
 //稭 樨, 묨 뤥   ᯨ᮪ 䠩
char Sector[512]; //!!!  ᪠  biosdisk
#define PANEL_PATH 38
 // ,  頥  

void itoa99 (MODE n, MODE *str) {
 //᫮  ࢠ [0,99]  ப 2 
 str[0]=n/10+'0'; str[1]=n%10+'0';
}

void GetDateItem (MODE *Buffer,MODE Day,MODE Mon,MODE Year) {
 //  ப  DD/MM/YY
 itoa99 (Day,  &Buffer[0]); itoa99 (Mon,  &Buffer[3]);
 itoa99 (Year, &Buffer[6]); Buffer[2]=Buffer[5]='/';
}

void GetTimeItem (MODE *Buffer,MODE Hour,MODE Min) {
 //६  ப  HH:MM
 itoa99 (Hour, &Buffer[0]); itoa99 (Min,  &Buffer[3]);
 Buffer[2]=':';
}

void GetCatalogItem (char *Buffer,struct ffblk *ffblk_) {
 //  ⠫
 int i,Year;
 MODE Day,Mon,c,attr;
 attr=ffblk_->ff_attrib;
 strcpy (Buffer,ffblk_->ff_name);
 if (attr!=0x10) tolower_ (Buffer);
 LeftSide (Buffer,12);
 i=ffblk_->ff_fdate;
 Day=i&0x001f;
 Mon=(i&0x01e0)>>5;
 Year=1980+((i&0xfe00)>>9);
 c=Year%100;
 GetDateItem (&Buffer[13],Day,Mon,c);
 i=ffblk_->ff_ftime;
 Day=(i&0xf800)>>11; //Hour
 Mon=(i&0x07e0)>>5; //Min
 GetTimeItem (&Buffer[22],Day,Mon);
 Buffer[21]=Buffer[27]=' ';
 if (attr==0x10) strcpy (&Buffer[28],"⠫");
 else ultoa_ (ffblk_->ff_fsize,&Buffer[28]);
 RightSide (&Buffer[28],10);
 Buffer[38]='\0';
 Buffer[39]=attr;
}

void GetShortPath (MODE *ShortPath,MODE *FullPath) {
 //    FullPath ⪨ ShortPath[PANEL_PATH]
 MODE i,*ptr;
 i=strlen (FullPath);
 if (i<=PANEL_PATH) strcpy (ShortPath,FullPath);
 else {
  ptr=strchr (FullPath,'\\');
  *ptr='\0';
  strcpy (ShortPath,FullPath);
  *ptr='\\';
  strcat (ShortPath,"\\...");
  ptr=strrchr (FullPath,'\\');
  strcat (ShortPath,ptr);
 }
}

void WritePanelItem (MODE *Buffer,MODE Row,MODE Col,MODE Attr) {
 //뢥  
 MODE *Dummy="12345678.123\0";
 MODE  attr=Buffer[39],c,i,j,Is;
 for (i=0; i<12; i++) Dummy[i]=' ';
 if (attr&0x07) Dummy[8]='';
 if (attr&0x10 && Buffer[0]=='.' && Buffer[1]=='.') {
  Dummy[0]=Dummy[1]='.';
 }
 else for (i=0,Is=NO; ; i++) {
  c=*(Buffer+i);
  if (c=='\0') break;
  else if (c=='.') { Is=YES; j=0; }
  else {
   if (Is) { Dummy [9+j]=c; j++; }
   else Dummy[i]=c;
  }
 }
 Dummy[12]='\0';
 write_string (Row,Col,Dummy,Attr);
}

void GetItemName (MODE *FullPath,int CurLen,MODE *Buffer,int Cur) {
 //  ࠭   FullPath
 if (FullPath[CurLen-1]!='\\') {
  FullPath[CurLen]='\\'; FullPath[CurLen+1]='\0';
 }
 strcat (FullPath,&Buffer[40*Cur]);
 RightMargin (FullPath);
}

void SelectDrive (MODE AllDisk,MODE *Disks,MODE *CurDisk) {
 // 롮 ᪠  ஢મ ⮢ a:, b:
 MODE *Bar=
  " $ESC$ ⪠  $F1$   $LEFT$   $RIGHT$ ࠢ  $ENTER$ 롮";
 KEY  Bar_Keys[]={ESC,F1,LEFT,RIGHT,ENTER},sim;
 MODE Pos_Keys[]={0,11,22,34,48,60},Num_Keys=5;
 MODE y1,y2,x1=10,x2=14,i,rev,attr,Curs,r,c;
 MODE far *GetStrHelp=
 "    롥 ॡ㥬  蠬 $\033$, $\032$  -\n"
 " $ENTER$     㪢, ᮮ-\n"
 "饩  ᪠.",
 far *GetHdrHelp="롮 ᪠";
 i=(AllDisk<<1)+3;
 y1=(80-i)>>1;
 y2=(80+i)>>1;
 if (y2-y1<21) y2=y1+21;
 save (x1,y1,x2,y2);
 rev=CYAN;
 ATTR=attr=0x70; //set_attr (BLACK, LIGHTGRAY);
 Fun_Bar (Bar);
 FILLER=' ';
 clear (x1,y1,x2,y2);
 ATTR=attr;
 box (x1+1,y1+1,x2-1,y2-1,0x02);
 center_string (x1+1,y1+1,y2-1," 롥 : ");
 CURSOR_OFF();
 for (i=0; i<AllDisk; i++) {
  write_char (x1+2,y1+3+(i<<1),Disks[i]-32);
  if (*CurDisk+'a'==Disks[i]) Curs=i;
 }
 CURSOR_ON(); attr=LIGHTGRAY;
 while (1) {
  change_attr (x1+2,y1+3+(Curs<<1),x1+2,y1+3+(Curs<<1),rev);
  if (Mouse) while (!Hit_Key()) {
   ms_state ();
   if (buttons==0x01) { //Left
    if (Fun_Bar_Keys (Num_Keys,Bar_Keys,Pos_Keys)) goto KEYBOARD;
    if (Mouse_In_Field (x1+2,y1+3, 1,1, 1,AllDisk, 0,1, &r, &c)) {
     change_attr (x1+2,y1+3+(Curs<<1),x1+2,y1+3+(Curs<<1),attr);
     Curs=c;
     change_attr (x1+2,y1+3+(Curs<<1),x1+2,y1+3+(Curs<<1),rev);
     Set_Key (1,ENTER);
     break;
    }
   }
  }
KEYBOARD:
  sim=Get_Key();
  change_attr (x1+2,y1+3+(Curs<<1),x1+2,y1+3+(Curs<<1),attr);
  switch (sim) {
   case ESC: goto OUT;
   case F1: StrHelp=GetStrHelp; HdrHelp=GetHdrHelp; Help (STR_HELP);
   Fun_Bar(Bar); break;
   case ENTER: *CurDisk=Curs; goto OUT;
   case LEFT:
    if (Curs==0) Curs=AllDisk-1;
    else Curs--;
   break;
   case RIGHT:
    if (Curs==AllDisk-1) Curs=0;
    else Curs++;
   break;
   case HOME: Curs=0; break;
   case END: Curs=AllDisk-1; break;
   default:
    if ((c=Find_Key ("aAbBcCdDeEfFgGhHiIjJkKlLmM"
		     "nNoOpPqQrRsStTuUvVwWxXyYzZ",
		     sim))!=NO_SIM) {
     for (i=0; i<AllDisk; i++) if (Disks[i]-'a'==c) {
      Curs=i;
      Set_Key (1,ENTER);
     }
    }
   break;
  }
 }
OUT:
 restore (x1,y1,x2,y2);
 return;
}

void SortFiles (MODE *Buffer,int All) {
 //   ७, ⠫ ।
 MODE *Ptr0="1234567890123456789012345678901234567890",
  *Ptr1,*Ptr2,*Ptr11,*Ptr22;
 MODE *Ext1="111",*Ext2="222",Atr1,Atr2,Jmp=NO;
 int i,j,k;
 if (Buffer[0]=='.') i=1; // .. ᥣ 
 else i=0;
 for (; i<All; i++) {
REFRESH:
  Ptr1=&Buffer[40*i];
  Atr1=(*(Ptr1+39))&0x10;
  Ptr11=strchr (Ptr1,'.');
  if (Ptr11!=NULL) {
   Ptr11++; strcpy_ (Ext1, Ptr11);
  }
  else Ext1[0]='\0';
  if (Jmp) Jmp=NO;
  else j=i+1;
  while (j<All) {
   Ptr2=&Buffer[40*j];
   Ptr22=strchr (Ptr2,'.');
   Atr2=(*(Ptr2+39))&0x10;
   if (Ptr22!=NULL) {
    Ptr22++;
    strcpy_ (Ext2, Ptr22);
   }
   else Ext2[0]='\0';
   k=stricmp(Ext2,Ext1);
   j++;
   if ( ((Atr2==0x10) && (Atr1==0)) || //   
	((Atr1==Atr2) &&
         (k<0 || // 
	  (k==0 && stricmp(Ptr2,Ptr1)<0)))) {//   
    memcpy (Ptr0,Ptr1,40);
    memcpy (Ptr1,Ptr2,40);
    memcpy (Ptr2,Ptr0,40);  //
    Jmp=YES; goto REFRESH;
   }
  }
 }
}

MODE Is_Mask (MODE *Mask) {
 //୥ 2, ᫨ ।  䠩, 1, ᫨ । ᪠, 0 - 訡
 MODE c,i,After1=NO,After2=NO,After3=NO,IdMask=NO,Kol=0,MaxLen=8;
 toupper_(Mask);
 for (i=0;;i++) {
  c=Mask[i];
  switch (c) {
   case '\0': return (IdMask?0x01:0x02);
   case '*': IdMask=YES; if (After2 || After1) return NO; After1=YES; break;
   case '?': IdMask=YES; Kol++; if (After1 || Kol>MaxLen) return NO;
    After2=YES; break;
   case '.': if (After3) return NO; After3=YES;
    After1=After2=NO; MaxLen=3; Kol=0; break;
   default:
    Kol++;
    if ((c>'@' && c<'[') || (Find_Key("-_$#&@!%(){}\'`~^",c)!=NO_SIM)) {
     if (After1 || After2 || Kol>MaxLen) return NO;
    }
    else return NO;
   break;
  }
 }
}

MODE WildName (MODE *Name, MODE *Mask) {
 // ᮪   ७
 MODE i,j,c,Next,AlMask=NO,AlName=NO;
 for (i=0,j=0; ; ) {
  c=*(Mask+i);
  switch (c) {
   case '*': return YES;
   case '?': goto NEXT_CHAR;
   default:
    if (*(Name+j)!=c) return NO;
NEXT_CHAR:
    if (!AlMask) {
     Next=*(Mask+i+1);
     if (Next=='\0') AlMask=YES;
     i++;
    }
    if (!AlName) {
     Next=*(Name+j+1);
     if (Next=='\0') AlName=YES;
     j++;
    }
    if ((AlMask==YES) && (AlName==NO)) return NO;
    else if (AlMask && AlName) return YES;
   break;
  }
 }
}

MODE WildCard (MODE *Name,MODE *Mask) {
 //YES, ᫨  䠩 Name   Mask
 MODE *Ptr1,*Ptr2,Ext1=YES,Ext2=YES,Ret1;
 Ptr1=strchr (Name,'.');
 if (Ptr1==NULL || (*(Ptr1+1)=='\0'))  Ext1=NO;
 else *Ptr1='\0';
 Ptr2=strchr (Mask,'.');
 if (Ptr2==NULL || (*(Ptr2+1)=='\0'))  Ext2=NO;
 else *Ptr2='\0';
 Ret1=WildName (Name,Mask);
 if (Ext1) { *Ptr1='.'; Ptr1++; }
 if (Ext2) { *Ptr2='.'; Ptr2++; }
 if (Ret1) {
  if (Ext1 && Ext2) Ret1=WildName (Ptr1,Ptr2);
  else if (Ext1 && !Ext2) Ret1=NO;
  else if (!Ext1 && Ext2) {
   if (!strcmp (Ptr2,"*")) Ret1=YES;
   else Ret1=NO;
  }
 }
 return (Ret1);
}

MODE Filer (MODE *Mask, MODE *Name) { //, MODE Mode) {
 // ୥    ࠭ 䠩
 // 頥 0, ᫨ 䠩 ࠭
 //            1,  
 //	       2, 訡 㯠  
 //            3, ୠ ᪠   䠩
 //          255, ⪠ ⨥ ESC
 MODE *Bar=
  " $ESC$ ⪠  $F1$   $DOWN$   $UP$   $F2$   $ENTER$ 롮";
 KEY  Bar_Keys[]={ESC,F1,DOWN,UP,F2,ENTER},sim;
 MODE Pos_Keys[]={0,11,22,33,43,52,64},beg;
 struct ffblk ffblk_;
 int AllFile,i,j,Next,Start,Cur,CurLen;
 MODE Disks[26],AllDisk,Portion,Ret,attr,rev,r,c,Disk,*Buffer;
 MODE x1=5,x2=20,y1=20,y2=59,Rows=12,Cols=3,Row=0,Col=0,LastRow,LastCol,OnPage;
 MODE FullPath[MAX_PATH], ShortPath[PANEL_PATH], GotoName[13], GotoFind=NO,
  Search=YES,row,col,LastPos=NO;
 MODE *Ptr;
 MODE far *GetStrHelp=
 "        ६  ॢ ⠫\n"    //Filer
 " ᬠਢ ᯨ᮪ 䠩   ࠭ \n"
 "᪥.\n"
 " ⨥ $ENTER$ ⢥ত 롮;\n"
 " $ESC$ - ⬥ 롮 䠩;\n"
 " $F2$  - ᬮ  㣮 ᪠.",
 far *GetHdrHelp="롮 䠩";
 WINDOW NoDrive = {
  11,30,16,50," ! ",
  "  X: $ ⮢$! ", YELLOW, LIGHTRED, CYAN,
  NO_HELP, YES, 0x00};

 row=Is_Mask (Mask);
 if (row==0) return 0x03; //訡
 else if (row==2) { // 䠩
  if (getcwd (FullPath, MAX_PATH)==NULL) return 0x02;
  c=strlen_(FullPath);
  if (FullPath[c-1]!='\\') {
   FullPath[c]='\\'; FullPath[c+1]='\0';
  }
  strcat (FullPath,Mask);
  return 0;
 }
 // Look for available disks:
 Disk=getdisk(); AllDisk=0;
 for (i=0;i<26;++i) {
  setdisk (i); // Try to set this disk;
  if (i==getdisk()) { // it is available
   Disks[AllDisk]=i+'a';
   AllDisk++;
  }
 }
 setdisk (Disk);

 AllFile=MEM_FILES; Portion=0;
 Buffer=(MODE *)malloc(40*MEM_FILES);
 if (Buffer==NULL) { Ret=0x01; goto OUT; }

 save (x1,y1,x2,y2);
 rev=0x30; //set_attr (BLACK, CYAN);
 ATTR=attr=0x1B;//set_attr (LIGHTCYAN, BLUE);
 Fun_Bar (Bar);
AGAIN:
 FILLER=' ';ATTR=attr;
 clear (x1,y1,x2,y2);
 box (x1,y1,x2,y2,0x02);
 HorizLine (x1+13,y1,y2,LINE_212);
 VertLine (x1,x2-2,y1+13,LINE_211);
 VertLine (x1,x2-2,y1+26,LINE_211);
 beg=DrawVertBar (x1,x2,y2);

 if (Search==NO) goto DRAW_PATH;

 if (getcwd (FullPath, MAX_PATH)==NULL) {
  Ret=0x02; goto OUT;
 }
 CurLen=strlen(FullPath);
 GetShortPath (ShortPath,FullPath);
 OnPage=36; //Rows*Cols;
DRAW_PATH:
 ATTR=0x70; //set_attr (BLACK, LIGHTGRAY);
 center_string (x1,y1+1,y2-1,ShortPath);
 ATTR=attr;
 if (Search==NO) goto DRAW_PAGE;

 Search=NO; Buffer[0]='\0';

FIND_DIRS:
 i=findfirst (".", &ffblk_, 0x10);
 if (!i) {
  strcpy (ffblk_.ff_name,"..");
  GetCatalogItem (Buffer,&ffblk_);
  j=1;
 }
 else j=0; // த⥫᪮
 i=findfirst ("*.*", &ffblk_, 0x37); // ⠫
 for (;;) {
  if (i) break;

  if ((ffblk_.ff_name[0]!='.') &&
      (ffblk_.ff_attrib==0x10 || WildCard (ffblk_.ff_name,Mask))) {
   if (j==AllFile) {
    Portion++; AllFile+=MEM_FILES;
    Buffer=(MODE *)realloc(Buffer, 40*(Portion+1)*MEM_FILES);
    if (Buffer==NULL) { Ret=0x01; goto OUT; }
   }
   GetCatalogItem (&Buffer[40*j],&ffblk_); j++;
  }
  i=findnext (&ffblk_);
 }
 Next=j; //    

 SortFiles (Buffer,Next); //㥬 䠩  ७
 Row=0; Col=0; Start=0;
 if (GotoFind) { //饬 ,  ண 﫨
  for (j=0; j<Next; j++) {
   Ptr=&Buffer[40*j];
   i=strpos_ (Ptr,' ');
   Push (Ptr+i);
   if (!stricmp (Ptr,GotoName)) Start=j;
   Pop (Ptr+i);
   if (Start) break;
  }
  GotoFind=NO;
 }
DRAW_PAGE:
 row=0; col=0; //ப  ⮫  ࠭
 for (j=Start; j<Next; j++) {
  WritePanelItem (&Buffer[40*j],x1+1+row,y1+1+col*13,attr);
  if (row<Rows-1) row++;
  else {
   row=0;
   if (col<Cols-1) col++;
   else break;
  }
 }
// End=j;
 LastRow=(row==0?(Next==0?1:Rows):row);
 LastCol=(row==0?(Next==0?1:(Next<=OnPage?col:col+1)):col+1); //!!!
 if (LastPos) { Row=LastRow-1; Col=LastCol-1; LastPos=NO; }

 while (1) {
AGAIN2:
  Cur=Start+Col*Rows+Row;
  WritePanelItem (&Buffer[40*Cur],x1+1+Row,y1+1+Col*13,rev);
  if (Next) beg=ChangeVertBar (Cur,Next,beg,x1,x2,y2);
  Buffer[40*Cur+12]=' ';
  write_string (x2-1,y1+1,&Buffer[40*Cur],0x1f);
  Buffer[40*Cur+12]='\0';
  if (Mouse) while (!Hit_Key()) {
   ms_state ();
   if (buttons==0x01) { //Left
    if (Fun_Bar_Keys (6,Bar_Keys,Pos_Keys)) goto KEYBOARD;
    if (MouseVertBar (x1,x2,y2)) goto KEYBOARD;
    if (Mouse_In_Field (x1+1,y1+1, 1,12, 12,3, 0,1, &r, &c)) {
     if ( !( (c==LastCol-1 && r>LastRow-1) || (c>LastCol-1)) ) {
      WritePanelItem (&Buffer[40*Cur],x1+1+Row,y1+1+Col*13,attr);
      if (Row==r && Col==c) Set_Key (1,ENTER);
      Row=r; Col=c;
      goto AGAIN2;
     }
    }
   }
  }
KEYBOARD:
  sim=Get_Key();
  WritePanelItem (&Buffer[40*Cur],x1+1+Row,y1+1+Col*13,attr);
  switch (sim) {
   case F1: //!!!
    StrHelp=GetStrHelp; HdrHelp=GetHdrHelp; Help (STR_HELP);
    Fun_Bar(Bar);
   break;
   case ESC:
    strcpy (Name,FullPath);
    strcat (Name,"\\");
    Ret=NO_SIM; goto OUT;
   case ENTER:
    if (Cur==0 && CurLen>3) { //뫪 
     Ptr=strrchr (FullPath,'\\');
     strcpy (GotoName, Ptr+1); //, 㤠 﫨
     if (Ptr) {
      if (*(Ptr-1)==':') Ptr++;
      *Ptr='\0';
      Search=YES;
      if (chdir(FullPath)) { Ret=0x02; goto OUT; }
      GotoFind=YES; goto AGAIN;
     }
    }
    else if (Buffer[40*Cur+39]==0x10) { // ⠫
     GetItemName (FullPath,CurLen,Buffer,Cur);
     if (chdir(FullPath)) { Ret=0x02; goto OUT; }
     Search=YES;
     goto AGAIN;
    }
    else {
//     if (Mode) { //   
      GetItemName (FullPath,CurLen,Buffer,Cur);
      strcpy (Name,FullPath);
/*     }
     else {
      strcpy (Name,&Buffer[40*Cur]);
      RightMargin(Name);
     } */
     Ret=0x00; // ࠭
     goto OUT;
    }
   case HOME: Start=0; Row=0; Col=0; goto AGAIN;
   case END:
    Start=Next-OnPage;
    if (Start<0) Start=0;
    if (Next>=OnPage) { Row=Rows-1; Col=Cols-1; }
    else LastPos=YES;
   goto AGAIN;
   case PAGE_DO:
    if (Next<OnPage) Set_Key (1,END);
    else {
     Start+=(OnPage-1);
     if (Start>Next-OnPage) Start=Next-OnPage;
     Row=Rows-1; Col=Cols-1;
     goto AGAIN;
    }
   break;
   case PAGE_UP:
    if (Next<OnPage) Set_Key (1,HOME);
    else {
     Start-=(OnPage-1);
     if (Start<0) Start=0;
     Row=0; Col=0;
     goto AGAIN;
    }
   break;
   case CTRL_UP: // த⥫᪨ ⠫
    if (CurLen>3) { //  ⠫
     Set_Key (2,HOME,ENTER);
    }
   break;
   case DOWN:
    if (Col==LastCol-1) {
     if (Row<LastRow-1) Row++;
     else if (Start<Next-OnPage) {
      Start++;
      //if (!(Start<Next-OnPage-1)) Row=0;
      goto AGAIN;
     }
    }
    else {
     if (Row==Rows-1) {
      Col++; Row=0;
     }
     else Row++;
    }
   break;
   case RIGHT:
    if (Col<LastCol-1) {
     Col++;
     if (Col==LastCol-1 && Row>LastRow-1) Row=LastRow-1;
    }
    else Set_Key (1,PAGE_DO);
   break;
   case UP:
    if (Col==0) {
     if (Row>0) Row--;
     else if (Start>0) {
      Start--; goto AGAIN;
     }
    }
    else {
     if (Row==0) {
      Col--; Row=Rows-1;
     }
     else Row--;
    }
   break;
   case LEFT:
    if (Col>0) Col--;
    else Set_Key (1,PAGE_UP);
   break;
   case F2:
SEL_DRIVE:
    row=Disk;
    SelectDrive (AllDisk,Disks,&Disk); //㫨   ᯨ᪥ ᪮
    Fun_Bar(Bar);
    Disk=Disks[Disk]-'a'; //稫  ᪠
    if (Disk!=row) {
     if (Disk<2) { // ஢, ⠢  ᪥
RE_READ:
      i = biosdisk(4,Disk,0,0,1,1,Sector);
      if (i==6) goto RE_READ;
      else if (i) { // ⮢
       NoDrive.str[6]=Disk+'A';
       MessageText (&NoDrive);
       Disk=row;
       goto SEL_DRIVE;
      }
     }
     setdisk (Disk);
     FullPath[0]='a'+getdisk();
     FullPath[1]=':';    FullPath[2]='\\';    FullPath[3]='\x0';
     Search=YES;
     goto AGAIN;
    }
    else ATTR=attr; //!!! ⠭ ਡ  ᮢ
   break;
   default: break;
  }
 }
OUT:
 free (Buffer);
 restore (x1,y1,x2,y2);
 toupper_(Name);
 return Ret;
}
